/* GCC */
#include <iostream>
#include <fstream>

using namespace std;

unsigned long long factNMod(unsigned long long num)
{
    unsigned long long fac = 1;
    for (unsigned long long i = 2; i <= num; ++i)
        fac *= i;
    return fac;
}
unsigned long long factsDiv(unsigned long long num1, unsigned long long num2)
{
    unsigned long long fac = 1;
    for (unsigned long long i = num2 + 1; i <= num1; ++i)
        fac *= i;
    return fac;
}

unsigned long long fact(unsigned long long num, unsigned long long mod = 0)
{
    if (!mod)
        return factNMod(num);

    num %= mod;
    unsigned long long fac = 1;
    for (unsigned long long i = 2; i <= num; ++i)
    {
        fac *= (i % mod);
        fac %= mod;
    }
    return fac % mod;
}

unsigned long long qPow(unsigned long long num, unsigned long long st, unsigned long long mod)
{
    if (st == 1)
        return num % mod;
    if (st % 2 == 0)
    {
        unsigned long long x = qPow(num, st / 2, mod) % mod;
        return x % mod * x % mod;
    }
    else
        return (num % mod) * (qPow(num, st - 1, mod) % mod);
}

unsigned long long modDiv(unsigned long long num1, unsigned long long num2, unsigned long long mod)
{
    return (max(num1, mod) - min(num1, mod)) * qPow(num2, mod, mod) % mod;
}

int main()
{
    //ifstream cin("cash.in");
    //ofstream cout("cash.out");
    unsigned long long m, n, p, r;
    cin >> m >> n >> p >> r;
    if (!r)
        cout << factsDiv(m + n, max(m, n)) / fact(min(n, m)) / fact(m - p);
    else
        cout << factsDiv(m + n, max(m, n)) / fact(min(n, m)) / fact(m - p) % r;

    cout << endl;
}
