/* GCC */
#include<fstream>
#include<vector>
#include<cmath>
#include<iostream>
using namespace std;
struct Coordinates {
    int x_;
    int y_;
    Coordinates(int x, int y) {
        x_=x;
        y_=y;
    }
    Coordinates() {
        x_=-1;
        y_=-1;
    }
};
bool operator<(const Coordinates& a, const Coordinates& b) {
    if (a.y_ < b.y_) {
        return true;
    }
    else if (a.y_==b.y_ && a.x_< b.x_) {
        return true;
    }
    else {
        return false;
    }
}
bool operator>(const Coordinates& a, const Coordinates& b) {
    if (a.y_ > b.y_) {
        return true;
    }
    else if (a.y_==b.y_ && a.x_> b.x_) {
        return true;
    }
    else {
        return false;
    }
}
bool operator==(const Coordinates& a, const Coordinates& b) {
    if (a.y_ == b.y_ && a.x_ == b.x_) {
        return true;
    }
    else {
        return false;
    }
}
struct Pair {
    Coordinates j_;
    Coordinates k_;
    Pair(int xJ, int yJ, int xK, int yK) {
        j_=Coordinates(xJ, yJ);
        k_=Coordinates(xK, yK);
    }
    Pair(Coordinates j, Coordinates k) {
        j_=j;
        k_=k;
    }
    void sortPair() {
        if (k_<j_) {
            Coordinates temp=k_;
            k_=j_;
            j_=temp;
        }
    }
};

bool operator>(const Pair& a, const Pair& b) {
    if (abs(a.j_.x_-a.k_.x_)/double(abs(a.j_.y_-a.k_.y_)) > abs(b.j_.x_-b.k_.x_)/double(abs(b.j_.y_-b.k_.y_))) {
        return true;
    }
    else {
        return false;
    }
}
bool operator<(const Pair& a, const Pair& b) {
    if (abs(a.j_.x_-a.k_.x_)/double(abs(a.j_.y_-a.k_.y_)) > abs(b.j_.x_-b.k_.x_)/double(abs(b.j_.y_-b.k_.y_))) {
        return true;
    }
    else {
        return false;
    }
}
bool operator==(const Pair& a, const Pair& b) {
    if (abs(a.j_.x_-a.k_.x_)/double(abs(a.j_.y_-a.k_.y_)) == abs(b.j_.x_-b.k_.x_)/double(abs(b.j_.y_-b.k_.y_))) {
        return true;
    }
    else {
        return false;
    }
}
bool operator<=(const Pair& a, const Pair& b) {
    if(a.j_<b.j_) return true;
    else if(a.j_==b.j_ && a.k_<b.k_) return true;
    else return false;
}
void display(const vector<unsigned int>& indexes, const vector<Coordinates>& points) {
    for(unsigned int i=0;i<indexes.size();i++) {
        cout<<points[indexes[i]].x_<<" "<<points[indexes[i]].y_<<endl;
    }
}
template<typename T>
void clearArr(vector<T>& a) {
    for(unsigned int i=0;i<a.size();i++) {
        a.pop_back();
    }
}
vector<Pair> findMaxLenght(const vector<Coordinates>& points, int usedMax=30001) {
    vector<unsigned int> mins(1, 0);
    vector<unsigned int> maxs;
    bool isFound=false;
    for(unsigned int i=0;i<points.size() && !isFound;i++) {
        if(points[i].x_<usedMax) {
            maxs=vector<unsigned int>(1, i);
            isFound=true;
        }
    }
    vector<Pair> vec;
    if(!isFound) {
        return vec;
    }
    for(unsigned int i=0;i<points.size();i++) {
        if(points[i].x_<points[mins[0]].x_) {
            clearArr<unsigned int>(mins);
            mins.push_back(i);
        }
        else if(points[i].x_==points[mins[0]].x_ && i!=0) {
            mins.push_back(i);
        }
        if(points[i].x_>points[maxs[0]].x_ && points[i].x_!=usedMax) {
            clearArr<unsigned int>(maxs);
            maxs.push_back(i);
        }
        else if(points[i].x_==points[maxs[0]].x_ && i!=0) {
            maxs.push_back(i);
        }
    }
    if(points[maxs[0]].y_ == points[mins[0]].y_) {
        return findMaxLenght(points, points[maxs[0]].x_);
    }
    else {
        for(unsigned int i=0;i<mins.size(); i++) {
            for(unsigned int j=0;j<maxs.size(); j++) {
                vec.push_back(Pair(points[mins[i]], points[maxs[j]]));
            }
        }
        return vec;
    }
}
vector<Pair> findMinHeight(const vector<Coordinates>& points) {
    vector<unsigned int> mins(1, 0);
    vector<unsigned int> secondMins;
    unsigned int startFrom;
    for(unsigned int i=0;i<points.size();i++) {
        if(points[i].y_<points[mins[0]].y_) {
            clearArr<unsigned int>(mins);
            mins.push_back(i);
        }
        else if(points[i].y_==points[mins[0]].y_ && i!=0) {
            mins.push_back(i);
        }
    }
    bool isFound=false;
    for(unsigned int i=0;i<points.size() && !isFound;i++) {
        if(points[i].y_!=points[mins[0]].y_) {
            secondMins=vector<unsigned int>(1, i);
            isFound=true;
            startFrom=i;
        }
    }
    vector<Pair> vec;
    if(!isFound) {
        return vec;
    }
    for(unsigned int i=startFrom;i<points.size();i++) {
        if(points[i].y_<points[secondMins[0]].y_ && points[i].y_>points[mins[0]].y_) {
            clearArr<unsigned int>(secondMins);
            secondMins.push_back(i);
        }
        else if(points[i].y_==points[secondMins[0]].y_ && i!=startFrom) {
            secondMins.push_back(i);
        }
    }
    for(unsigned int i=0;i<mins.size(); i++) {
        for(unsigned int j=0;j<secondMins.size(); j++) {
            vec.push_back(Pair(points[mins[i]], points[secondMins[j]]));
        }
    }
    return vec;
}
vector<Pair> findMinPairs(const vector<Pair>& pairs) {
    vector<Pair> minPairs(1, pairs[0]);
    for(unsigned int i=0;i<pairs.size();i++) {
        if(pairs[i]<minPairs[0]) {
            minPairs.clear();
            minPairs.push_back(pairs[i]);
        }
        else if(pairs[i]==minPairs[0] && i!=0) {
            minPairs.push_back(pairs[i]);
        }
    }
    return minPairs;
}
Pair findWritablePair(vector<Pair>& pairs) {
    for(unsigned int i=0;i<pairs.size();i++) {
        pairs[i].sortPair();
    }
    unsigned int writablePair=0;
    for(unsigned int i=0;i<pairs.size();i++) {
        if(pairs[i]<=pairs[writablePair]) {
            writablePair=i;
        }
    }
    return pairs[writablePair];
}
void writeNull() {
    ofstream fout;
    fout.open("slope.out");
    fout<<"0";
    fout.close();
}
void display(const vector<Pair>& pairs) {
    for(unsigned int i=0;i<pairs.size();i++) {
        cout<<pairs[i].j_.x_<<" "<<pairs[i].j_.y_<<" "<<pairs[i].k_.x_<<" "<<pairs[i].k_.y_<<endl;
    }
}

int main() {
    vector<Coordinates> points;
    int n;
    ifstream fin;
    fin.open("slope.in");
    fin>>n;
    int x, y;
    for(int i=0;i<n;i++) {
        fin>>x>>y;
        points.push_back(Coordinates(x, y));
    }
    fin.close();
    vector<Pair> minHeightPairs=findMinHeight(points);
    vector<Pair> maxLenghtPairs=findMaxLenght(points);
    if(minHeightPairs.size()==0 || maxLenghtPairs.size()==0) {
        writeNull();
    }
    else {
        vector<Pair> minPairs1=findMinPairs(minHeightPairs);
        vector<Pair> minPairs2=findMinPairs(maxLenghtPairs);
        Pair res(-1, -1, -1, -1);
        if(minPairs1[0]>minPairs2[0]) {
            res=findWritablePair(minPairs1);
        }
        else {
            res=findWritablePair(minPairs2);
        }
        ofstream fout;
        fout.open("slope.out");
        fout<<res.j_.x_<<" "<<res.j_.y_<<" "<<res.k_.x_<<" "<<res.k_.y_;
        fout.close();
    }
    return 0;
}
