/* GCC */

#define maxn 100000

#include <stdio.h>
#include <algorithm>

using namespace std;

int x[maxn], y[maxn];

inline int comp(int a, int b, int c, int d)
{
    int up = a * d - b * c;
    if (up > 0)
        return 1;
    if (up < 0)
        return -1;
    return 0;
}

inline void lexcheck(int &i, int &j)
{
    if (y[i] > y[j])
        swap(i, j);
}

inline int lexcomp(int &i1, int &j1, int &i2, int &j2)
{
    if (y[i1] > y[i2])
    {
        swap(i1, i2);
        swap(j1, j2);
        return 0;
    }
    if (x[i1] > x[i2])
    {
        swap(i1, i2);
        swap(j1, j2);
        return 0;
    }
    if (y[j1] > y[j2])
    {
        swap(i1, i2);
        swap(j1, j2);
        return 0;
    }
    if (x[j1] > x[j2])
    {
        swap(i1, i2);
        swap(j1, j2);
        return 0;
    }
    return 0;
}

int main()
{
    freopen("slope.in", "r", stdin);
    freopen("slope.out", "w", stdout);
    int n, maxtu = 0, maxtd = 1, maxp1, maxp2;
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
        scanf("%d %d", &x[i], &y[i]);
    for (int i = 0; i < n; i++)
        for (int j = i + 1; j < n; j++)
            if ((x[i] != x[j]) && (y[i] != y[j]))
            {
                int tu, td;
                tu = abs(x[i] - x[j]);
                td = abs(y[i] - y[j]);
                switch (comp(maxtu, maxtd, tu, td))
                {
                case -1:
                        maxtu = tu;
                        maxtd = td;
                        maxp1 = i;
                        maxp2 = j; //gotta swap 'em
                        lexcheck(maxp1, maxp2);
                        break;
                case 0:
                        int k, l;//check for lexicography
                        k = i;
                        l = j;
                        lexcheck(k, l);
                        lexcomp(maxp1, maxp2, k, l);
                        break;
                }
            }
    if (maxtu > 0)
        printf("%d %d %d %d\n", x[maxp1], y[maxp1], x[maxp2], y[maxp2]);
    else
        printf("0\n");
    return 0;
}
