/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <Math.h>

using namespace std;

vector<int> coordsX;
vector<int> coordsY;

float minSin = 2;

int resCoordsX1, resCoordsX2, resCoordsY1, resCoordsY2;

float findSin(int x1, int y1, int x2, int y2) {
    float fsin = 1;
    if (y2 == y1) {
        fsin = 0;
    }
    else {
        if (y2 > y1) {
            swap(y2, y1);
            swap(x2, x1);
        }
        int x3 = x1;
        int y3 = y2;

        int a = abs(y1 - y3);
        int b = abs(x2 - x3);

        float c = sqrt(a * a + b * b);

        fsin = a / c;
    }
    return fsin;
}

void setResCoords(int x1, int y1, int x2, int y2) {
    resCoordsX1 = x1;
    resCoordsY1 = y1;

    resCoordsX2 = x2;
    resCoordsY2 = y2;
}

int main() {
    ifstream fin("slope.in");
    ofstream fout("slope.out");

    int n;
    fin >> n;
    coordsX.resize(n);
    coordsY.resize(n);

    for (int i = 0; i < n; i++) {
        int x, y;
        fin >> coordsX[i] >> coordsY[i];
    }

    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            float curSin = findSin(coordsX[i], coordsY[i], coordsX[j], coordsY[j]);

            if (curSin <= minSin && curSin > 0) {
                //------------------------------------

                int xi, yi, xk, yk;
                xi = coordsX[i];
                yi = coordsY[i];

                xk = coordsX[j];
                yk = coordsY[j];

                float temp1 = abs((xi - xk) / (yi - yk));
                float temp2 = abs((xk - xi) / (yk - yi));

                if (temp2 > temp1) {
                    swap(yi, yk);
                    swap(xi, xk);
                }

                if (minSin == curSin) {

                    if (resCoordsY1 > yi) {
                        minSin = curSin;
                        setResCoords(xi, yi, xk, yk);
                    }
                    else {
                        if ((resCoordsX1 > xi) && (resCoordsY1 == yi)) {
                            minSin = curSin;
                            setResCoords(xi, yi, xk, yk);
                        }
                        else {
                            if ((resCoordsY2 > yk) && (resCoordsX1 == xi)) {
                                minSin = curSin;
                                setResCoords(xi, yi, xk, yk);
                            }
                            else {
                                if ((resCoordsX2 > xk) && (resCoordsY2 == yk)) {
                                    minSin = curSin;
                                    setResCoords(xi, yi, xk, yk);
                                }
                            }
                        }
                    }
                }
                //------------------------------------
                else {
                    minSin = curSin;
                    setResCoords(coordsX[i], coordsY[i], coordsX[j], coordsY[j]);
                }
            }
        }
    }

    if (minSin > 1) {
        fout << 0;
    }
    else {
        fout << resCoordsX1 << " " << resCoordsY1 << " " << resCoordsX2 << " " << resCoordsY2;
    }

    fout << endl;

    fin.close();
    fout.close();
    return 0;
}
